Index: /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Security.Server/3.3/HeuristicLabSecurityServerApplication.cs
===================================================================
--- /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Security.Server/3.3/HeuristicLabSecurityServerApplication.cs	(revision 4171)
+++ /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Security.Server/3.3/HeuristicLabSecurityServerApplication.cs	(revision 4171)
@@ -0,0 +1,127 @@
+﻿using System;
+using System.Collections.Generic;
+using HeuristicLab.PluginInfrastructure;
+using System.Text;
+using System.ServiceModel;
+using System.ServiceModel.Description;
+using System.Net;
+using System.Linq;
+using HeuristicLab.Security.Contracts.Interfaces;
+using System.Windows.Forms;
+
+namespace HeuristicLab.Security.Server {
+
+  [Application("Security Server", "Server application for the security.", true)]
+  public class HeuristicLabSecurityServerApplication : ApplicationBase {
+    public const string STR_PermissionManager = "PermissionManager";
+    public const string STR_SecurityManager = "SecurityManager";
+
+    int DEFAULT_PORT_SM = 9111;
+    int DEFAULT_PORT_PM = 9112;
+
+    private Dictionary<string, ServiceHost> runningServices = new Dictionary<string, ServiceHost>();
+    private NetTcpBinding binding = (NetTcpBinding)HeuristicLab.Hive.Contracts.WcfSettings.GetBinding();
+
+    private enum Services {
+      SecurityManager,
+      PermissionManager,
+      All
+    }
+
+    private bool AddMexEndpoint(ServiceHost serviceHost) {
+      if (serviceHost != null) {
+        ServiceMetadataBehavior behavior = new ServiceMetadataBehavior();
+        serviceHost.Description.Behaviors.Add(behavior);
+
+        return serviceHost.AddServiceEndpoint(
+          typeof(IMetadataExchange),
+          MetadataExchangeBindings.CreateMexTcpBinding(),
+          "mex") != null;
+      } else
+        return false;
+    }
+
+    private String StartService(Services svc, IPAddress ipAddress, int port) {
+      string curServiceHost = "";
+      Uri uriTcp;
+      String result = "";
+      IEnumerable<ISecurityManager> securityManagerInstances = ApplicationManager.Manager.GetInstances<ISecurityManager>();
+      IEnumerable<IPermissionManager> permissionManagerInstances = ApplicationManager.Manager.GetInstances<IPermissionManager>();
+      ServiceHost serviceHost = null;
+      switch (svc) {
+        case Services.PermissionManager:
+          if (permissionManagerInstances.Count() > 0) {
+            uriTcp = new Uri("net.tcp://" + ipAddress + ":" + port + "/SecurityServer/");
+            serviceHost = new ServiceHost(permissionManagerInstances.First().GetType(), uriTcp);
+            serviceHost.AddServiceEndpoint(typeof(IPermissionManager), binding, STR_PermissionManager);
+            curServiceHost = STR_PermissionManager;
+            result = uriTcp.ToString() + STR_PermissionManager;
+          }
+          break;
+        case Services.SecurityManager:
+          if (securityManagerInstances.Count() > 0) {
+            uriTcp = new Uri("net.tcp://" + ipAddress + ":" + port + "/SecurityServer/");
+            serviceHost = new ServiceHost(securityManagerInstances.First().GetType(), uriTcp);
+            serviceHost.AddServiceEndpoint(typeof(ISecurityManager), binding, STR_SecurityManager);
+            curServiceHost = STR_SecurityManager;
+            result = uriTcp.ToString() + STR_SecurityManager;
+          }
+          break;
+        case Services.All:
+          throw new InvalidOperationException("Not supported!");
+        default:
+          return null;
+      }
+      if ((serviceHost != null) && (!String.IsNullOrEmpty(curServiceHost))) {
+        AddMexEndpoint(serviceHost);
+        //    WcfSettings.SetServiceCertificate(serviceHost);
+        serviceHost.Open();
+        runningServices.Add(curServiceHost, serviceHost);
+        return result;
+      } else
+        return null;
+    }
+
+    private void StopService(Services svc) {
+      ServiceHost svcHost = null;
+      switch (svc) {
+        case Services.PermissionManager:
+          runningServices.TryGetValue(STR_PermissionManager, out svcHost);
+          break;
+        case Services.SecurityManager:
+          runningServices.TryGetValue(STR_SecurityManager, out svcHost);
+          break;
+        case Services.All:
+          foreach (KeyValuePair<string, ServiceHost> item in runningServices)
+            item.Value.Close();
+          return;
+        default:
+          throw new InvalidOperationException("Not supported!");
+      }
+      svcHost.Close();
+    }
+
+    public override void Run() {
+      IPAddress[] addresses = Dns.GetHostAddresses(Dns.GetHostName());
+      int index = 0;
+      if (System.Environment.OSVersion.Version.Major >= 6) {
+        for (index = addresses.Length - 1; index >= 0; index--)
+          if (addresses[index].AddressFamily == System.Net.Sockets.AddressFamily.InterNetwork)
+            break;
+      }
+
+      //Start services and record their base address
+      Dictionary<string, String> baseAddrDict = new Dictionary<string, String>();
+      baseAddrDict.Add(STR_PermissionManager,
+        StartService(Services.PermissionManager, addresses[index], DEFAULT_PORT_PM));
+      baseAddrDict.Add(STR_SecurityManager,
+        StartService(Services.SecurityManager, addresses[index], DEFAULT_PORT_SM));
+
+      SecurityServer securityServer = new SecurityServer(baseAddrDict);
+
+      Application.Run(securityServer);
+
+      StopService(Services.All);
+    }
+  }
+}
Index: /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Security.Server/3.3/HeuristicLabSecurityServerPlugin.cs
===================================================================
--- /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Security.Server/3.3/HeuristicLabSecurityServerPlugin.cs	(revision 4171)
+++ /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Security.Server/3.3/HeuristicLabSecurityServerPlugin.cs	(revision 4171)
@@ -0,0 +1,34 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Text;
+using HeuristicLab.PluginInfrastructure;
+
+namespace HeuristicLab.Security.Server {
+  [Plugin("HeuristicLab.Security.Server-3.3")]
+  [PluginFile("HeuristicLab.Security.Server-3.3.dll", PluginFileType.Assembly)]
+  [PluginDependency("HeuristicLab.Hive.Contracts", "3.3")]
+  [PluginDependency("HeuristicLab.Security.Contracts", "3.3")]
+  public class HeuristicLabSecurityServerPlugin : PluginBase {
+  }
+}
Index: /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Security.Server/3.3/Properties/AssemblyInfo.frame
===================================================================
--- /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Security.Server/3.3/Properties/AssemblyInfo.frame	(revision 4170)
+++ /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Security.Server/3.3/Properties/AssemblyInfo.frame	(revision 4171)
@@ -55,5 +55,4 @@
 // by using the '*' as shown below:
 // [assembly: AssemblyVersion("1.0.*")]
-[assembly: AssemblyVersion("3.3.0.$WCREV$")]
+[assembly: AssemblyVersion("3.3.0.0")]
 [assembly: AssemblyFileVersion("3.3.0.$WCREV$")]
-[assembly: AssemblyBuildDate("$WCNOW$")]
Index: /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Security.Server/3.3/SecurityServer.cs
===================================================================
--- /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Security.Server/3.3/SecurityServer.cs	(revision 4170)
+++ /branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Security.Server/3.3/SecurityServer.cs	(revision 4171)
@@ -13,8 +13,8 @@
       InitializeComponent();
       String uri;
-      baseAddrDict.TryGetValue(SecurityServerApplication.STR_PermissionManager, out uri);
+      baseAddrDict.TryGetValue(HeuristicLabSecurityServerApplication.STR_PermissionManager, out uri);
       if (uri != null)
         this.labelPermission.Text = uri.ToString();
-      baseAddrDict.TryGetValue(SecurityServerApplication.STR_SecurityManager, out uri);
+      baseAddrDict.TryGetValue(HeuristicLabSecurityServerApplication.STR_SecurityManager, out uri);
       if (uri != null)
         this.labelSecurity.Text = uri.ToString();
